Class: Aws::Imagebuilder::Types::CreateComponentRequest

Inherits:
Struct
  • Object
show all
Defined in:
gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb

Overview

Constant Summary collapse

SENSITIVE =
[]

Instance Attribute Summary collapse

Instance Attribute Details

#change_description ⇒ String

The change description of the component. Describes what change has been made in this version, or what makes this version different from other versions of the component.

Returns:

  • (String)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end

#client_token ⇒ String

A unique, case-sensitive identifier you provide to ensure that the operation runs no more than one time. If you retry a request with the same client token, Image Builder returns the original response without running the operation again. For more information, see Ensuring idempotency in the Amazon EC2 API Reference.

A suitable default value is auto-generated. You should normally not need to pass this option.

Returns:

  • (String)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end

#data ⇒ String

Component data contains inline YAML document content for the component. Alternatively, you can specify the uri of a YAML document file stored in Amazon S3. However, you cannot specify both properties.

Returns:

  • (String)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end

#description ⇒ String

Describes the contents of the component.

Returns:

  • (String)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end

#dry_run ⇒ Boolean

Validates the required permissions and request parameters without performing the operation. If validation succeeds, the operation returns a DryRunOperationException error response.

Returns:

  • (Boolean)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end

#kms_key_id ⇒ String

The Amazon Resource Name (ARN) that uniquely identifies the KMS key used to encrypt this component. This can be either the Key ARN or the Alias ARN. For more information, see Key identifiers (KeyId) in the Key Management Service Developer Guide. If you don't specify a key, Image Builder encrypts the component data with a KMS key that Image Builder owns.

Returns:

  • (String)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end

#name ⇒ String

The name of the component. Image Builder generates the component ARN from a normalized form of the name, so names that differ only in case, spaces, or underscores count as the same name. If a component with the same name and semantic version already exists in your account in the same Amazon Web Services Region, the request creates a new build version for it. If the content is also identical to the latest build version, the request fails because the component already exists.

Returns:

  • (String)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end

#platform ⇒ String

The operating system platform of the component.

Returns:

  • (String)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end

#semantic_version ⇒ String

The semantic version of the component. This version follows the semantic version syntax.

The semantic version has four nodes: <major>.<minor>.<patch>/<build>. You can assign values for the first three, and can filter on all of them.

Assignment: For the first three nodes, you can assign any positive integer value, including zero. The upper limit is 230-1, or 1073741823, for each node. Image Builder automatically assigns the build number to the fourth node.

Patterns: You can use any numeric pattern that adheres to the assignment requirements for the nodes that you can assign. For example, you might choose a software version pattern, such as 1.0.0, or a date, such as 2021.01.01.

Returns:

  • (String)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end

#supported_os_versions ⇒ Array<String>

The operating system (OS) version supported by the component. If the OS information is available, a prefix match is performed against the base image OS version during image recipe creation.

Returns:

  • (Array<String>)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end

#tags ⇒ Hash<String,String>

The tags that apply to the component.

Returns:

  • (Hash<String,String>)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end

#uri ⇒ String

The uri of a YAML component document file. This must be an S3 URL (s3://bucket/key), and you must have permission to access the S3 bucket it points to. If you use Amazon S3, you can specify component content up to your service quota for component size, which is 64 KB by default.

Alternatively, you can specify the YAML document inline, using the component data property. You cannot specify both properties.

Returns:

  • (String)


1189
1190
1191
1192
1193
1194
1195
1196
1197
1198
1199
1200
1201
1202
1203
1204
# File 'gems/aws-sdk-imagebuilder/lib/aws-sdk-imagebuilder/types.rb', line 1189

class CreateComponentRequest < Struct.new(
  :name,
  :semantic_version,
  :description,
  :change_description,
  :platform,
  :supported_os_versions,
  :data,
  :uri,
  :kms_key_id,
  :tags,
  :client_token,
  :dry_run)
  SENSITIVE = []
  include Aws::Structure
end